/*****************************************************************************/
/*                                                                           */
/*  Hyperpanel OS                       File "include/boot_stm32.h           */
/*  Constants and definitions for boot_stm32.s                               */
/*                                                                           */
/*  Author : JYA                        Last modification : 01/12/2019       */
/*                                                                           */
/*  (c) Copyright Hyperpanel Lab, All Rights Reserved                        */
/*  IDDN.FR.001.320001.*.S.P.1990.000.10000                                  */
/*                                                                           */
/*****************************************************************************/


/*  Some explanations ========================================================


         1  Defines
         2  Structures and typedefs
         3  Public variables
         4  Prototypes of public procedures


*/


#ifndef BOOT_STM32_H                   /* If this file is not already        */
#define BOOT_STM32_H                   /* included, include it.              */


/*
    1    Defines
    ____________
*/

#define PRE_ENDPGM             0       /* End of preinit program             */
#define PRE_B                  1       /* Inconditionnal branch              */
#define PRE_BEQ                2       /* Conditionnal branch if EQ          */
#define PRE_BNE                3       /* Conditionnal branch if EQ          */
#define PRE_JSR                4       /* Jump to subroutine                 */
#define PRE_RETURN             5       /* REturn from subroutine             */

#define PRE_POKE               6       /* Write 4 bytes with mask            */
#define PRE_POKES              7       /* Write 2 bytes with mask            */
#define PRE_PEEK               8       /* Read 4 bytes with mask             */
#define PRE_PEEKS              9       /* Read 2 bytes with mask             */
#define PRE_WAIT10US          10       /* Wait for a number of 10 msec       */
#define PRE_WAITUNTIL         11       /* Wait for a pattern to appear       */
#define PRE_HALT              12       /* Infinite loop                      */
#define PRE_BKPT              13       /* Stop and give control to GDB       */

#define PEMPTY        0xFFFFFFFF       /* Empty parameter                    */

/*
    2    Structures and typedefs
    ____________________________
*/


/*
    3    Public variables
    _____________________
*/


/*
    4    Prototypes of public procedures
    ____________________________________
*/



#endif                                 /* End of BOOT_STM32_H                */
