/*****************************************************************************/
/*                                                                           */
/*  Hyperpanel OS                       File "stm32/include/drv_srf.h"       */
/*  SRF driver specific context structure for stm32 board.                   */
/*                                                                           */
/*  Author : PJB                        Last modification : 07/01/2011       */
/*                                                                           */
/*  (c) Copyright Hyperpanel Lab, All Rights Reserved                        */
/*  IDDN.FR.001.320001.*.S.P.1990.000.10000                                  */
/*                                                                           */
/*****************************************************************************/


/*  Some explanations =======================================================


         1  Defines
         2  Structures and typedefs
         3  Public variables
         4  Prototypes of public procedures


*/


#ifndef DRV_SRF_H                      /* Si le fichier n'est pas deja       */
#define DRV_SRF_H                      /* inclus, inclure son contenu        */


/*
    1    Defines
    ____________


         Ce fichier include definit la structure de contexte SRF afin qu'il
puisse etre importe d'une part dans le board, et d'autre part dans le driver
SRF.

*/


/*
    2    Structures and typedefs
    ____________________________
*/


typedef struct                         /* Srf_ctx                            */
  BEGIN                                /* -----------------------------------*/
    UINT            iodcar           ; /* IOD fourni par xdrv_itf1.          */
    UCHAR           snum             ; /* Numero pin pour la veille radio    */
    UCHAR           sbit             ; /* Numero bit  "   "   "      "       */
    UCHAR           sval             ; /* Niveau actuel du pin de veille     */
  END               Srf_ctx          ; /* -----------------------------------*/

typedef struct                         /* Srf_def                            */
  BEGIN                                /* -----------------------------------*/
    UCHAR           snum             ; /* Numero pin pour la veille radio    */
    UCHAR           sbit             ; /* Numero bit  "   "   "      "       */
  END               Srf_def          ; /* -----------------------------------*/


/*
    3    Public variables
    _____________________
*/


/*
    3    Prototypes of public procedures
    ____________________________________
*/


#endif                                 /* #ifndef DRV_SRF_H                  */
