/*****************************************************************************/
/*                                                                           */
/*  Hyperpanel OS                       File "include/keycode.h"             */
/*  Constants and definitions for keyboards / RCU.                           */
/*                                                                           */
/*  Author : JYA                        Last modification : 15/03/2017       */
/*                                                                           */
/*  (c) Copyright Hyperpanel Lab, All Rights Reserved                        */
/*  IDDN.FR.001.320001.*.S.P.1990.000.10000                                  */
/*                                                                           */
/*****************************************************************************/


/*  Some explanations =======================================================


         1  Defines
         2  Structures and typedefs
         3  Public variable
         4  Prototypes of public procedures


*/


#ifndef KEYCODE_H                      /* If this file is not already        */
#define KEYCODE_H                      /* included, include it.              */


/*
    1    Defines
    ____________
*/


/*****************************************************************************
 * Key code are splitted in two files "keycode.h" and "keym.txt"             *
 * because of too much declared mnemonics.                                   *
 *****************************************************************************/


#define KEY_SPACE      (INT) 32        /* Touche espace                      */
                                    
#define KEY_0          (INT) 48        /* Touche du clavier.                 */
#define KEY_1          (INT) 49        /* Touche du clavier.                 */
#define KEY_2          (INT) 50        /* Touche du clavier.                 */
#define KEY_3          (INT) 51        /* Touche du clavier.                 */
#define KEY_4          (INT) 52        /* Touche du clavier.                 */
#define KEY_5          (INT) 53        /* Touche du clavier.                 */
#define KEY_6          (INT) 54        /* Touche du clavier.                 */
#define KEY_7          (INT) 55        /* Touche du clavier.                 */
#define KEY_8          (INT) 56        /* Touche du clavier.                 */
#define KEY_9          (INT) 57        /* Touche du clavier.                 */
                                    
#define KEY_A          (INT) 65        /* Touche du clavier.                 */
#define KEY_B          (INT) 66        /* Touche du clavier.                 */
#define KEY_C          (INT) 67        /* Touche du clavier.                 */
#define KEY_D          (INT) 68        /* Touche du clavier.                 */
#define KEY_E          (INT) 69        /* Touche du clavier.                 */
#define KEY_F          (INT) 70        /* Touche du clavier.                 */
#define KEY_G          (INT) 71        /* Touche du clavier.                 */
#define KEY_H          (INT) 72        /* Touche du clavier.                 */
#define KEY_I          (INT) 73        /* Touche du clavier.                 */
#define KEY_J          (INT) 74        /* Touche du clavier.                 */
#define KEY_K          (INT) 75        /* Touche du clavier.                 */
#define KEY_L          (INT) 76        /* Touche du clavier.                 */
#define KEY_M          (INT) 77        /* Touche du clavier.                 */
#define KEY_N          (INT) 78        /* Touche du clavier.                 */
#define KEY_O          (INT) 79        /* Touche du clavier.                 */
#define KEY_P          (INT) 80        /* Touche du clavier.                 */
#define KEY_Q          (INT) 81        /* Touche du clavier.                 */
#define KEY_R          (INT) 82        /* Touche du clavier.                 */
#define KEY_S          (INT) 83        /* Touche du clavier.                 */
#define KEY_T          (INT) 84        /* Touche du clavier.                 */
#define KEY_U          (INT) 85        /* Touche du clavier.                 */
#define KEY_V          (INT) 86        /* Touche du clavier.                 */
#define KEY_W          (INT) 87        /* Touche du clavier.                 */
#define KEY_X          (INT) 88        /* Touche du clavier.                 */
#define KEY_Y          (INT) 89        /* Touche du clavier.                 */
#define KEY_Z          (INT) 90        /* Touche du clavier.                 */
                                    
#define KEY_a          (INT) 97        /* Touche du clavier.                 */
#define KEY_b          (INT) 98        /* Touche du clavier.                 */
#define KEY_c          (INT) 99        /* Touche du clavier.                 */
#define KEY_d          (INT)100        /* Touche du clavier.                 */
#define KEY_e          (INT)101        /* Touche du clavier.                 */
#define KEY_f          (INT)102        /* Touche du clavier.                 */
#define KEY_g          (INT)103        /* Touche du clavier.                 */
#define KEY_h          (INT)104        /* Touche du clavier.                 */
#define KEY_i          (INT)105        /* Touche du clavier.                 */
#define KEY_j          (INT)106        /* Touche du clavier.                 */
#define KEY_k          (INT)107        /* Touche du clavier.                 */
#define KEY_l          (INT)108        /* Touche du clavier.                 */
#define KEY_m          (INT)109        /* Touche du clavier.                 */
#define KEY_n          (INT)110        /* Touche du clavier.                 */
#define KEY_o          (INT)111        /* Touche du clavier.                 */
#define KEY_p          (INT)112        /* Touche du clavier.                 */
#define KEY_q          (INT)113        /* Touche du clavier.                 */
#define KEY_r          (INT)114        /* Touche du clavier.                 */
#define KEY_s          (INT)115        /* Touche du clavier.                 */
#define KEY_t          (INT)116        /* Touche du clavier.                 */
#define KEY_u          (INT)117        /* Touche du clavier.                 */
#define KEY_v          (INT)118        /* Touche du clavier.                 */
#define KEY_w          (INT)119        /* Touche du clavier.                 */
#define KEY_x          (INT)120        /* Touche du clavier.                 */
#define KEY_y          (INT)121        /* Touche du clavier.                 */
#define KEY_z          (INT)122        /* Touche du clavier.                 */
                                    
#define KEY_DELETE     (INT)127        /* Touche delete                (127) */
#define KEY_CLEAR      (INT)  5        /* Touche control-e               (5) */
#define KEY_BACKSPACE  (INT)  8        /* Touche backspace               (8) */
#define KEY_TAB        (INT)  9        /* Touche tab                     (9) */
#define KEY_NEWLINE    (INT) 10        /* Touche enter (non mappee)     (10) */
#define KEY_ADDLINE    (INT) 14        /* Touche add line (non mappee)  (14) */
#define KEY_CTRL_P     (INT) 16        /* Touche change panel actif     (16) */
#define KEY_QUIT       (INT) 17        /* touche quit                   (17) */
#define KEY_DELLINE    (INT) 25        /* Touche del line (non mappee)  (25) */
#define KEY_ESC        (INT) 27        /* Touche escape                 (27) */
                                    
#define KEY_SHIFT      (INT)320        /* Touche du clavier.                 */
#define KEY_SHIFT_F1   (INT)321        /* Touche du clavier.                 */
#define KEY_SHIFT_F2   (INT)322        /* Touche du clavier.                 */
#define KEY_SHIFT_F3   (INT)323        /* Touche du clavier.                 */
#define KEY_SHIFT_F4   (INT)324        /* Touche du clavier.                 */
#define KEY_SHIFT_F5   (INT)325        /* Touche du clavier.                 */
#define KEY_SHIFT_F6   (INT)326        /* Touche du clavier.                 */
#define KEY_SHIFT_F7   (INT)327        /* Touche du clavier.                 */
#define KEY_SHIFT_F8   (INT)328        /* Touche du clavier.                 */
#define KEY_SHIFT_F9   (INT)329        /* Touche du clavier.                 */
#define KEY_SHIFT_F10  (INT)330        /* Touche du clavier.                 */
#define KEY_SHIFT_F11  (INT)331        /* Touche du clavier.                 */
#define KEY_SHIFT_F12  (INT)332        /* Touche du clavier.                 */
                                    
#define KEY_HOME       (INT)343        /* Touche "Home".                     */
#define KEY_PAGE_UP    (INT)345        /* Touche "Page Up".                  */
#define KEY_PAUSE      (INT)350        /* Touche "Pause".                    */
#define KEY_END        (INT)351        /* Touche "End".                      */
#define KEY_PAGE_DOWN  (INT)353        /* Touche "Page Down.                 */
#define KEY_INSERT     (INT)354        /* Touche "Insert".                   */
#define KEY_SUPCHAR    (INT)355        /* Touche "Sup Char"         (pas w32)*/
#define KEY_SHIFT_HOME (INT)356        /* Touche shift+"Home".               */
#define KEY_SHIFT_END  (INT)357        /* Touche shift+"End".                */
#define KEY_CTRL_HOME  (INT)358        /* Touche controle+"Home".            */
#define KEY_CTRL_END   (INT)359        /* Touche controle+"End".             */
#define KEY_HELP       (INT)360        /* Touche "Help"             (pas w32)*/
                                    
#define KEY_COPY       (INT)361        /* Touche controle-c ou "Copy".       */
#define KEY_PASTE      (INT)362        /* Touche controle-v ou "Paste".      */
#define KEY_CUT        (INT)363        /* Touche controle-x ou "Cut".        */
#define KEY_OPEN       (INT)364        /* Touche controle-a ou "Open".       */
#define KEY_CLRLINE    (INT)365        /* Touche CLRLINE            (pas w32)*/
#define KEY_SELECT     (INT)366        /* Touche SELECT             (pas w32)*/
#define KEY_MMENU      (INT)367        /* Touche MENU                        */
#define KEY_SYSTEM     (INT)368        /* Touche SYSTEM             (pas w32)*/
                                    
#define KEY_ALT        (INT)400        /* Touche du clavier.                 */
#define KEY_ALT_A      (INT)401        /* Touche du clavier.                 */
#define KEY_ALT_B      (INT)402        /* Touche du clavier.                 */
#define KEY_ALT_C      (INT)403        /* Touche du clavier.                 */
#define KEY_ALT_D      (INT)404        /* Touche du clavier.                 */
#define KEY_ALT_E      (INT)405        /* Touche du clavier.                 */
#define KEY_ALT_F      (INT)406        /* Touche du clavier.                 */
#define KEY_ALT_G      (INT)407        /* Touche du clavier.                 */
#define KEY_ALT_H      (INT)408        /* Touche du clavier.                 */
#define KEY_ALT_I      (INT)409        /* Touche du clavier.                 */
#define KEY_ALT_J      (INT)410        /* Touche du clavier.                 */
#define KEY_ALT_K      (INT)411        /* Touche du clavier.                 */
#define KEY_ALT_L      (INT)412        /* Touche du clavier.                 */
#define KEY_ALT_M      (INT)413        /* Touche du clavier.                 */
#define KEY_ALT_N      (INT)414        /* Touche du clavier.                 */
#define KEY_ALT_O      (INT)415        /* Touche du clavier.                 */
#define KEY_ALT_P      (INT)416        /* Touche du clavier.                 */
#define KEY_ALT_Q      (INT)417        /* Touche du clavier.                 */
#define KEY_ALT_R      (INT)418        /* Touche du clavier.                 */
#define KEY_ALT_S      (INT)419        /* Touche du clavier.                 */
#define KEY_ALT_T      (INT)420        /* Touche du clavier.                 */
#define KEY_ALT_U      (INT)421        /* Touche du clavier.                 */
#define KEY_ALT_V      (INT)422        /* Touche du clavier.                 */
#define KEY_ALT_W      (INT)423        /* Touche du clavier.                 */
#define KEY_ALT_X      (INT)424        /* Touche du clavier.                 */
#define KEY_ALT_Y      (INT)425        /* Touche du clavier.                 */
#define KEY_ALT_Z      (INT)426        /* Touche du clavier.                 */
                                    
#define KEY_ALT_UP     (INT)427        /* Touche du clavier                  */
#define KEY_ALT_RIGHT  (INT)428        /* Touche du clavier                  */
#define KEY_ALT_LEFT   (INT)429        /* Touche du clavier                  */
#define KEY_ALT_DOWN   (INT)430        /* Touche du clavier                  */
                                    
#define KEY_SHIFT_TAB  (INT)509        /* Touche du clavier                  */
#define KEY_CTRL       (INT)520        /* Touche du clavier                  */
#define KEY_NEXT_UP    (INT)521        /* Touche du clavier                  */
#define KEY_NEXT_DOWN  (INT)522        /* Touche du clavier                  */
#define KEY_NEXT_LEFT  (INT)523        /* Touche du clavier                  */
#define KEY_NEXT_RIGHT (INT)524        /* Touche du clavier                  */


/* Touches du front de panel ----------------------------------------------- */

#define FPKEY_POW      (INT)700        /* Code de front de panel POWER       */
#define FPKEY_MENU     (INT)701        /* Code de front de panel MENU        */
#define FPKEY_OK       (INT)702        /* Code de front de panel OK          */
#define FPKEY_DOWN     (INT)703        /* Code de front de panel UP          */
#define FPKEY_UP       (INT)704        /* Code de front de panel DOWN        */
#define FPKEY_LEFT     (INT)705        /* Code de front de panel LEFT        */
#define FPKEY_RIGHT    (INT)706        /* Code de front de panel RIGHT       */
#define FPKEY_LOWP     (INT)707        /* Code de front de panel LOW POWER   */


/*
    2    Structures and typedefs
    ____________________________
*/


/*
    3    Public variable
    ____________________
*/


/*
    4    Prototypes of public procedures
    ____________________________________
*/


#endif                                 /* End of KEYCODE_H.                  */
