/*****************************************************************************/
/*                                                                           */
/*  Hyperpanel OS                       File "include/mem_dat.h"             */
/*  Constants and definitions for DAT memory area.                           */
/*                                                                           */
/*  Author : RC                         Last modification : 10/04/2001       */
/*                                                                           */
/*  (c) Copyright Hyperpanel Lab, All Rights Reserved                        */
/*  IDDN.FR.001.320001.*.S.P.1990.000.10000                                  */
/*                                                                           */
/*****************************************************************************/


/*  Some explanations =======================================================


         1  Defines
         2  Structures and typedefs
         3  Public variable
         4  Prototypes of public procedures


*/


#ifndef MEM_DAT_H                      /* If this file is not already        */
#define MEM_DAT_H                      /* included, include it.              */


/*
    1    Defines
    ____________
*/


/*
    2    Structures and typedefs
    ____________________________
*/


/* Structure de description d'un contexte utilisateur -----------------------*/

typedef struct                       /* Description d'un contexte d'         */
  BEGIN                              /* utilisateur.                         */
   INT      maxsize                 ;/* Taille maximum d'un element.         */
   INT      priv                    ;/* Taille zone privee a l'utilisateur.  */
  END Desc_dat_ctx;                  /*                                      */


/* Structure de description d'un segmet STR ---------------------------------*/

typedef struct                       /* Description d'un segment             */
 BEGIN                               /*                                      */
  INT       type_data               ;/* Type d'un element de la table        */
  INT       size_data               ;/* Taille d'un element                  */
  INT       maxi_data               ;/* Nombre d'elements de la table        */
  INT       free_data               ;/* Nombre d'elements libres             */
  INT       offt_indx               ;/* Offset de la zone des indexs         */
  INT       offt_data               ;/* Offset du premier element            */
 END Desc_dat_seg;                   /*                                      */


/*
    3    Public variable
    ____________________
*/


/*
    4    Prototypes of public procedures
    ____________________________________
*/


  IWORD init_dat            (void                                            );
  IWORD alloc_dat_user_id   (IWORD,UCHAR*                                    );
  IWORD free_dat_user_id    (IWORD                                           );
  IWORD alloc_dat           (IWORD,INT,INT,INT,IWORD,INT*,UCHAR**,UCHAR**    );
  IWORD free_dat            (IWORD,INT                                       );
  void  free_dat3           (INT,UCHAR*                                      );
  IWORD get_dat_info        (IWORD,INT,INT*,UCHAR**,UCHAR**,INT*             );
  void  get_dat_info2       (IWORD,INT,INT*,UCHAR**,UCHAR**,INT*             );
  void  get_dat_info3       (INT,UCHAR*,INT*,UCHAR**,UCHAR**,INT*            );


#endif                                 /* End of MEM_DAT_H.                  */
