/*****************************************************************************/
/*                                                                           */
/*  Hyperpanel OS                       File "include/memstr.h"              */
/*  Constants and definitions for memstr manager.                            */
/*                                                                           */
/*  Author : RC                         Last modification : 10/04/2001       */
/*                                                                           */
/*  (c) Copyright Hyperpanel Lab, All Rights Reserved                        */
/*  IDDN.FR.001.320001.*.S.P.1990.000.10000                                  */
/*                                                                           */
/*****************************************************************************/


/*  Some explanations =======================================================


         1  Defines
         2  Structures and typedefs
         3  Public variable
         4  Prototypes of public procedures


*/


#ifndef MEMSTR_H                       /* If this file is not already        */
#define MEMSTR_H                       /* included, include it.              */


/*
    1    Defines
    ____________
*/


/*
    2    Structures and typedefs
    ____________________________
*/


/* Structure de description d'un contexte utilisateur -----------------------*/

typedef struct                       /* Description d'un contexte d'         */
  BEGIN                              /* utilisateur.                         */
   SHORT                     gran   ;/* Granularite des allocations.         */
   SHORT                     maxsize;/* Taille max d'une zone en granules.   */
   USHORT                    nbseg  ;/* Nb de segments alloues               */
   USHORT                    maxseg ;/* Nb max de segments allouables        */
  END Desc_str_ctx;                  /*                                      */


/* Structure de description d'une zone --------------------------------------*/

typedef struct                       /* Description d'une zone.              */
  BEGIN                              /*                                      */
   USHORT                    off    ;/* Offset en granules.                  */
   SHORT                     sze    ;/* Taille en granules.                  */
  END Desc_str;                      /* ( < 0 -> occupe; > 0 -> libre)       */


/* Structure de description d'un segmet STR ---------------------------------*/

typedef struct                       /* Description d'un segment             */
 BEGIN                               /*                                      */
  USHORT    nb_zone                 ;/* nombre de zones au total             */
  USHORT    nb_alloc                ;/* nombre de zones allouees             */

  SHORT     free_sze                ;/* taille totale non allouee            */

  SHORT     free_max_sze            ;/* taille de la plus grande zone libre  */
  USHORT    free_max_id             ;/* id     de la plus grande zone libre  */
  USHORT    free_1st_id             ;/* id     de la 1ere        zone libre  */
 END Desc_str_seg;                   /*                                      */


/*
    3    Public variables
    _____________________
*/


/*
    4    Prototypes of public procedures
    ____________________________________
*/


  IWORD init_str            (void                                            );
  IWORD alloc_str_user_id   (IWORD,IWORD,IWORD,UCHAR*                        );
  IWORD free_str_user_id    (IWORD                                           );
  IWORD alloc_str           (IWORD,INT,IWORD,INT*,UCHAR**                    );
  IWORD free_str            (IWORD,INT                                       );
  void  free_str3           (INT,UCHAR*                                      );
  IWORD get_str_info        (IWORD,INT,UCHAR**,INT*                          );
  void  get_str_info2       (IWORD,INT,UCHAR**,INT*                          );
  void  get_str_info3       (INT,UCHAR*,UCHAR**,INT*                         );
  UCHAR*get_str_info4       (INT                                             );
  IWORD print_str           (void                                            );


#endif                                 /* End of MEMSTR_HR.                  */
