/*****************************************************************************/
/*                                                                           */
/*  Hyperpanel OS                       File "include/module.h"              */
/*  Constants and definitions for PanTalk modules.                           */
/*                                                                           */
/*  Author : JYA                        Last modification : 23/03/2002       */
/*                                                                           */
/*  (c) Copyright Hyperpanel Lab, All Rights Reserved                        */
/*  IDDN.FR.001.320001.*.S.P.1990.000.10000                                  */
/*                                                                           */
/*****************************************************************************/


/*  Some explanations =======================================================


         1  Defines
         2  Structures and typedefs
         3  Public variable
         4  Prototypes of public procedures


*/


#ifndef MODULE_H                       /* If this file is not already        */
#define MODULE_H                       /* included, include it.              */


/*
    1    Defines
    ____________
*/


#define ABORT_MODULE     (UCHAR)0      /* Parametre de "free_module".        */
#define UNLOAD_MODULE    (UCHAR)1      /* Parametre de "free_module".        */


/*
    2    Structures and typedefs
    ____________________________
*/


typedef struct                      /* Structure de description d'un module  */
 BEGIN                              /* ------------------------------------- */
  INT          name              ;  /* Nom du module.                        */
  INT          panini            ;  /* Nom du premier panel.                 */
  INT          scrini            ;  /* Nom du script d'init.                 */
  INT          scrend            ;  /* Nom du script de fin.                 */
  USHORT       nb_ref            ;  /* Nombre de references                  */
  UCHAR        vlc               ;  /* Load/Unload: Voie log. appelante.     */
  UCHAR        idc               ;  /* Load/Unload: Module appelant.         */
  CHAR         fmt               ;  /* Module ascii/binaire.                 */
  CHAR         auc               ;  /* Load/Unload: Automate appelant.       */
 END Hmod_ctx                    ;  /* ------------------------------------- */


/*
    3    Public variables
    _____________________
*/


/*
    4    Prototypes of public procedures
    ____________________________________
*/


  IWORD init_module         (void                                            );
  IWORD mod_alloc_ctx       (Hmod_ctx**                                      );
  IWORD mod_free_ctx        (Hmod_ctx*                                       );
  IWORD get_module_id       (CHAR*,INT,INT*                                  );
  IWORD get_module_name     (INT,CHAR*                                       );
  IWORD extract_module_id   (CHAR*,INT*,CHAR*                                );
  IWORD mod_inc_ref         (INT                                             );
  void  mod_dec_ref         (INT                                             );
  IWORD unload_module       (INT,INT*                                        );
  IWORD free_module         (IWORD,IWORD                                     );


#endif                                 /* End of MODULE_H.                   */
