/*****************************************************************************/
/*                                                                           */
/*  Hyperpanel OS                       File "stm32/include/sys_stm32.h"     */
/*  Stm32 system peripherics constantes definitions.                         */
/*                                                                           */
/*  Author : PJB                        Last modification : 15/10/2015       */
/*                                                                           */
/*  (c) Copyright Hyperpanel Lab, All Rights Reserved                        */
/*  IDDN.FR.001.320001.*.S.P.1990.000.10000                                  */
/*                                                                           */
/*****************************************************************************/


/*  Some explanations =======================================================


         1  Defines
         2  Structures and typedefs
         3  Public variables
         4  Prototypes of public procedures


*/


#ifndef SYS_STM32_H                     /* Si le fichier n'est pas deja       */
#define SYS_STM32_H                    /* inclus, inclure son contenu        */

/*
    1    Defines
    ____________
*/



/*
    2    Structures et typedefs
    ___________________________
*/


/*
    3    Public variables
    _____________________
*/

extern const Sdrv_desc sdrv_sysm3           ; /* SYS   system drv interface  */
extern const Sdrv_desc sdrv_sysm4           ; /* SYS   system drv interface  */
extern const Sdrv_desc sdrv_timarmv7m       ; /* TIME  system drv interface  */


/*
    4    Prototypes of public procedures
    ____________________________________
*/

IWORD  get_hclk            (void                                            );
IWORD  sys_rst             (IWORD                                           );
IWORD  sys_ena             (IWORD, IWORD                                    );

IWORD  handlerTIM_armv7m   (IWORD,IWORD                                     );

#endif                                 /* #ifndef SYS_STM32_H                */
