/*****************************************************************************/
/*                                                                           */
/*  HyperPanel VMOS                     File "stm32re/include/hpl_macro.s"   */
/*  Assembly constants and definitions specific to stm32 targets.            */
/*                                                                           */
/*  Author : AL                         Last modification : 17/11/2017       */
/*                                                                           */
/*  (c) Copyright HyperPanel Lab, All Rights Reserved                        */
/*  IDDN.FR.001.320001.*.S.P.1990.000.10000                                  */
/*                                                                           */
/*****************************************************************************/

/*****************************************************************************
 * This macro is used to define a procedure written in assembly language.    *
 * STM32 targets only support Thumb ISA.                                     *
 *****************************************************************************/

.macro MACRO_PROCEDURE name            /* Procedure definition ------------- */
    .section    .text  , "ax"          /* Code section                       */
    .thumb_func                        /* Thumb function.                    */
    \name :                            /* Procedure entry point              */
.endm                                  /* ---------------------------------- */

.macro MACRO_ENDPROC                   /* End of procedure ----------------- */
.endm                                  /* ---------------------------------- */

.macro MACRO_LABEL name                /* Label definition ----------------- */
    .thumb_func                        /* Thumb function.                    */
    \name :                            /* Procedure entry point              */
.endm                                  /* ---------------------------------- */

