/*
**  Myapp.h - Sample code for STM32 HyperpanelOS =============== 02/19/19 =  **
**                                                                           **
**  Prototypes, defines and structures                                       **
**                                                                           **
**  =======================================================================  **
*/


/* Prototypes of functions ..................................................*/

static int     usnd_start       (int                                        ) ;
static int     usnd_stop        (int                                        ) ;
static int     usnd_resp        (int                                        ) ;
static int     usnd_end         (int                                        ) ;
static int     urcu_send        (int                                        ) ;
static int     urcu_tostart     (int                                        ) ;
static int     urcu_stop        (int                                        ) ;
static void    req_snd_start    (int, unsigned int, unsigned char*, int     ) ;
static void    req_snd_stop     (int                                        ) ;

static void    open_asy         (void                                       ) ;
static void    close_asy        (void                                       ) ;
static void    open_gpio        (void                                       ) ;
static void    close_gpio       (void                                       ) ;
static void    open_led         (void                                       ) ;
static void    close_led        (void                                       ) ;
static void    open_kbd         (void                                       ) ;
static void    close_kbd        (void                                       ) ;
static void    open_dac         (void                                       ) ;
static void    close_dac        (void                                       ) ;

static int     empt             (int                                        ) ;
static int     pmen             (int                                        ) ;
static int     pdtc             (void                                       ) ;
static int     ptim             (int                                        ) ;
static int     pgrp             (int                                        ) ;
static int     pcmd             (int                                        ) ;
static int     pchr             (int                                        ) ;
static int     pcap             (int                                        ) ;
static int     perr             (int                                        ) ;
static int     tcfg             (int                                        ) ;
static int     tinp             (int                                        ) ;
static int     tssy             (int                                        ) ;
static int     tchr             (int                                        ) ;
static int     scfg             (int                                        ) ;
static int     sval             (int                                        ) ;
static int     sled             (int                                        ) ;
static int     sint             (int                                        ) ;
static int     rasy             (int                                        ) ;
static int     rdac             (int                                        ) ;
static int     rrcu             (int                                        ) ;
static int     ewreq            (int                                        ) ;
static int     eroreq           (int                                        ) ;
static int     erreq            (int                                        ) ;
static int     ldreq            (int                                        ) ;
static int     lcreq            (int                                        ) ;
static int     ltcreq           (int                                        ) ;
static int     sapt             (int                                        ) ;
static int     sdpt             (int                                        ) ;
static int     srcu             (int                                        ) ;
static int     scap             (int                                        ) ;
static int     sret             (int                                        ) ;
static int     scon             (int                                        ) ;
static int     rest             (int                                        ) ;

static int     ev_opt           (int                                        ) ;
static int     ev_asy0_rcv      (void                                       ) ;
static int     ev_asy0_snd      (void                                       ) ;
static int     ev_asy12_rcv     (int                                        ) ;
static int     ev_asy12_snd     (int                                        ) ;
static int     ev_gpio012_in    (int                                        ) ;
static int     ev_i2c_end       (void                                       ) ;
static int     ev_kbd_rcv       (void                                       ) ;
static int     ev_msec          (void                                       ) ;

static int     wait_myevents    (void                                       ) ;
static void    fill256          (unsigned char*,int                         ) ;


/* Internal defines of this module ------------------------------------------*/

#define  AUT_USND              20      // Automaton number
#define  VLASY1                 0      // Logical way for serial ASY1
#define  VLASY2                 1      // Logical way for serial ASY2
#define  VLDAC                  2      // Logical way for DAC
#define  VLSNDRCU               3      // Logical way for RCU transmitter
#define  VLNB                   4      // Number of Logical ways of AUT_USND
#define  ASYMAX                 3      // Number of ASY ports
#define  LGRCV12              128      // Token sizes for ASY1 and ASY2
#define  LGCHR                  6      // "bufchr" input Buffer size

#define  TICK               10000      // Code for tick event
                                
#define  EV_ASY0_RCV            0      // Incoming data on ASY\DEV0
#define  EV_ASY1_RCV            1      // Incoming data on ASY\DEV1
#define  EV_ASY2_RCV            2      // Incoming data on ASY\DEV2
#define  EV_ASY0_SND            3      // Sent data on ASY\DEV0
#define  EV_ASY1_SND            4      // Sent data on ASY\DEV1
#define  EV_ASY2_SND            5      // Sent data on ASY\DEV2
#define  EV_GPIO0_IN           10      // GPIO input pin state change
#define  EV_GPIO1_IN           11      // GPIO input pin state change
#define  EV_GPIO2_IN           12      // GPIO input pin state change
#define  EV_I2C_END            20      // I2C job ended
#define  EV_KBD_RCV            30      // Key press or release event
#define  EV_MSEC               40      // "msec" milliseconds
                                

/* Parameter values for pmen (print menu) ...................................*/

#define  MMAIN                  0      // Main menu
#define  MI2C                   1      // I2C menu
#define  MCONF                  2      // Choice of configuration menu

#define  MASY1PT                3      // Select ASY1 transmit pattern
#define  MASY2PT                4      // Select ASY2 transmit pattern
#define  MDACPT                 5      // Select DAC  transmit pattern

#define  MASY1                  6      // Serial ASY1 options list menu
#define  MBAUD1                 7      // Baudrate config menu
#define  MBITS1                 8      // Number of bits config menu
#define  MSTOP1                 9      // Stop bits config menu
#define  MPAR1                 10      // Parity config
#define  MFLOW1                11      // Flow control config
#define  MFLUSH1               12      // Flush condition config
#define  MTEMPO1               13      // Temporization config

#define  MASY2                 14      // Serial ASY2 options list menu
#define  MBAUD2                15      // Baudrate config menu
#define  MBITS2                16      // Number of bits config menu
#define  MSTOP2                17      // Stop bits config menu
#define  MPAR2                 18      // Parity config
#define  MFLOW2                19      // Flow control config
#define  MFLUSH2               20      // Flush condition config
#define  MTEMPO2               21      // Temporization config

#define  MGPIO                 22      // Gpio BUT0 options list menu
#define  MPTIM                 23      // Software polling delay menu
#define  MPCNT                 24      // Software polling count menu
#define  MBUT                  25      // Buttons parameters menu
#define  MMON1                 26      // BUT1 Monitor mode menu
#define  MDTIM1                27      // BUT1 Hardware polling delay menu
#define  MDCNT1                28      // BUT1 Hardware polling count menu
#define  MMON2                 29      // BUT1 Monitor mode menu
#define  MDTIM2                30      // BUT1 Hardware polling delay menu
#define  MDCNT2                31      // BUT1 Hardware polling count menu
#define  MMON3                 32      // BUT1 Monitor mode menu
#define  MDTIM3                33      // BUT1 Hardware polling delay menu
#define  MDCNT3                34      // BUT1 Hardware polling count menu

#define  MRCU                  35      // RCU option list menu
#define  MOTMIN                36      // Start symbol on time minimum
#define  MOTMAX                37      // Start symbol on time maximum
#define  MSTMIN                38      // Start symbol symbol time minimum
#define  MSTMAX                39      // Start symbol symbol time maximum
#define  MCAP                  40      // Ongoing symbols capture
#define  MERR                  41      // Display an error code
#define  NB_PAGES              42      // Number of menu pages


/* Parameters values for pgrp (print group of variables) ....................*/

#define  GMAIN                  0     // Displayed variables in MMAIN menu
#define  GCONF                  1     // Displayed variables in MCONF menu
#define  GASY1                  2     // Displayed variables in MASY1 menu
#define  GASY2                  3     // Displayed variables in MASY2 menu
#define  GGPIO                  4     // Displayed variables in MGPIO menu
#define  GBUT                   5     // Displayed variables in MBUT  menu
#define  GRCU                   6     // Displayed variables in MRCU  menu


/* Code events for the menus ................................................*/

#define  OPT_0                  0      // Menu option 0
#define  OPT_1                  1      // Menu option 1
#define  OPT_2                  2      // Menu option 2
#define  OPT_3                  3      // Menu option 3
#define  OPT_4                  4      // Menu option 4
#define  OPT_5                  5      // Menu option 5
#define  OPT_6                  6      // Menu option 6
#define  OPT_7                  7      // Menu option 7
#define  OPT_8                  8      // Menu option 8
#define  OPT_9                  9      // Menu option 9
#define  OPT_ENTER             10      // Key OK/Return
#define  OPT_BACK              11      // Key OK/Return
#define  OPT_ESC               12      // Key OK/Return
#define  OPT_BUT1              13      // Button 1
#define  OPT_BUT2              14      // Button 2
#define  OPT_BUT3              15      // Button 3
#define  OPT_BUT4              16      // Button 4 (USR)
#define  OPT_CAPT              17      // End of capture event
#define  OPT_TIME              30      // Hidden option (timeout)
#define  OPT_I2C_END           31      // I2C job end
#define  OPT_INVALID           -1      // Invalid menu option
#define  OPT_IGNO              -2      // Simply ignore
#define  OPT_ERROR             -3      // Treatment has set an error code

#define  RMAIN    (100 +   MMAIN)      // Condition return to MMAIN
#define  RI2C     (100 +    MI2C)      // Condition return to MI2C
#define  RCONF    (100 +   MCONF)      // Condition return to MCONF

#define  RASY1P   (100 + MASY1PT)      // Condition return to MASY1PT
#define  RASY2P   (100 + MASY2PT)      // Condition return to MASY2PT
#define  RDACPT   (100 +  MDACPT)      // Condition return to MDACPT

#define  RASY1    (100 +   MASY1)      // Condition return to MASY1
#define  RBAUD1   (100 +  MBAUD1)      // Condition return to MBAUD1
#define  RBITS1   (100 +  MBITS1)      // Condition return to MBITS1
#define  RSTOP1   (100 +  MSTOP1)      // Condition return to MSTOP1
#define  RPAR1    (100 +   MPAR1)      // Condition return to MPAR1   
#define  RFLOW1   (100 +  MFLOW1)      // Condition return to MFLOW1
#define  RFLUSH1  (100 + MFLUSH1)      // Condition return to MFLUSH1
#define  RTEMPO1  (100 + MTEMPO1)      // Condition return to MTEMPO1

#define  RASY2    (100 +   MASY2)      // Condition return to MASY2
#define  RBAUD2   (100 +  MBAUD2)      // Condition return to MBAUD2
#define  RBITS2   (100 +  MBITS2)      // Condition return to MBITS2
#define  RSTOP2   (100 +  MSTOP2)      // Condition return to MSTOP2
#define  RPAR2    (100 +   MPAR2)      // Condition return to MPAR22
#define  RFLOW2   (100 +  MFLOW2)      // Condition return to MFLOW2
#define  RFLUSH2  (100 + MFLUSH2)      // Condition return to MFLUSH2
#define  RTEMPO2  (100 + MTEMPO2)      // Condition return to MTEMPO2

#define  RGPIO    (100 +   MGPIO)      // Condition return to MGPIO
#define  RPTIM    (100 +   MPTIM)      // Condition return to MPTIM
#define  RPCNT    (100 +   MPCNT)      // Condition return to MPCNT
#define  RBUT     (100 +    MBUT)      // Condition return to MBUT
#define  RMON1    (100 +   MMON1)      // Condition return to MMON1
#define  RDTIM1   (100 +  MDTIM1)      // Condition return to MDTIM1
#define  RDCNT1   (100 +  MDCNT1)      // Condition return to MDCNT1
#define  RMON2    (100 +   MMON2)      // Condition return to MMON2
#define  RDTIM2   (100 +  MDTIM2)      // Condition return to MDTIM2
#define  RDCNT2   (100 +  MDCNT2)      // Condition return to MDCNT2
#define  RMON3    (100 +   MMON3)      // Condition return to MMON3
#define  RDTIM3   (100 +  MDTIM3)      // Condition return to MFTIM3
#define  RDCNT3   (100 +  MDCNT3)      // Condition return to MDCNT1

#define  RRCU     (100 +    MRCU)      // Condition return to MRCU
#define  ROTMIN   (100 +  MOTMIN)      // Condition return to MOTMIN
#define  ROTMAX   (100 +  MOTMAX)      // Condition return to MOTMAX
#define  RSTMIN   (100 +  MSTMIN)      // Condition return to MSTMIN
#define  RSTMAX   (100 +  MSTMAX)      // Condition return to MSTMAX
#define  RCAP     (100 +    MCAP)      // Condition return to MCAP


/* Indexes in the "cfg[]" array .............................................
   Those are also the parameters values for tcfg/scfg and sval
*/

#define  VRED                   0     // MMAIN  Start/Stop pattern on RED
#define  VGREEN                 1     // MMAIN  Start/Stop pattern on GREEN
#define  VYELLO                 2     // MMAIN  Start/Stop pattern on YELLOW
#define  VASY1                  3     // MMAIN  Start/Stop serial line ASY1
#define  VASY2                  4     // MMAIN  Start/Stop serial line ASY2
#define  VDAC                   5     // MMAIN  Start/Stop audio DAC
#define  VUHFRCU                6     // MMAIN  Start/Stop UHF RCU transmitter

#define  VASY1PT                7     // MCONF  Set ASY1 transmit pattern
#define  VASY2PT                8     // MCONF  Set ASY2 transmit pattern
#define  VDACPT                 9     // MCONF  Set DAC transmit pattern

#define  VBAUD1                10     // MASY1  Set baudrate
#define  VBITS1                11     // MASY1  Set number of bits per symbol
#define  VSTOP1                12     // MASY1  Set number of stop bits
#define  VPAR1                 13     // MASY1  Set parity bit
#define  VDMA1                 14     // MASY1  Enable/Disable DMA
#define  VFLOW1                15     // MASY1  Set flow control
#define  VFLUSH1               16     // MASY1  Set flush mode
#define  VTEMPO1               17     // MASY1  Set flush temporization
#define  VSPEED1               18     // MASY1  Toggle reception speed

#define  VBAUD2                19     // MASY1  Set baudrate
#define  VBITS2                20     // MASY1  Set number of bits per symbol
#define  VSTOP2                21     // MASY1  Set number of stop bits
#define  VPAR2                 22     // MASY1  Set parity bit
#define  VDMA2                 23     // MASY1  Enable/Disable DMA
#define  VFLOW2                24     // MASY1  Set flow control
#define  VFLUSH2               25     // MASY1  Set flush mode
#define  VTEMPO2               26     // MASY1  Set flush temporization
#define  VSPEED2               27     // MASY1  Toggle reception speed

#define  VPTIM                 28     // MGPIO  Set software polling delay
#define  VPCNT                 29     // MGPIO  Set software polling count
#define  VMON1                 30     // MBUT1  Set monitor mode
#define  VDTIM1                31     // MBUT1  Set hardware polling delay
#define  VDCNT1                32     // MBUT1  Set hardware polling count
#define  VMON2                 33     // MBUT1  Set monitor mode
#define  VDTIM2                34     // MBUT1  Set hardware polling delay
#define  VDCNT2                35     // MBUT1  Set hardware polling count
#define  VMON3                 36     // MBUT1  Set monitor mode
#define  VDTIM3                37     // MBUT1  Set hardware polling delay
#define  VDCNT3                38     // MBUT1  Set hardware polling count

#define  VINPUT                39     // RCU receiver input number
#define  VNUMRCU               40     // RCU database entry number
#define  VONMIN                41     // RCU start ON  min
#define  VONMAX                42     // RCU start ON  max
#define  VSTMIN                43     // RCU start SYMB min
#define  VSTMAX                44     // RCU start SYMB max
#define  VMAX                  45     // Number of entries of "cfg[]"


/* Values to set "cfg[]" array entries ......................................*/

#define  CFG_STOPPED            0      // Main page: STOPPED
#define  CFG_STARTED            1      // Main page: STARTED

#define  CFG_600                0      // Baudrate: 1200 bauds
#define  CFG_1200               1      // Baudrate: 1200 bauds
#define  CFG_2400               2      // Baudrate: 2400 bauds
#define  CFG_9600               3      // Baudrate: 9600 bauds
#define  CFG_19200              4      // Baudrate: 19200 bauds
#define  CFG_38400              5      // Baudrate: 38400 bauds
#define  CFG_57600              6      // Baudrate: 57600 bauds
#define  CFG_115200             7      // Baudrate: 115200 bauds
                                 
#define  CFG_6BITS              0      // Nb bits: 6 bits/sym
#define  CFG_7BITS              1      // Nb bits: 7 bits/sym
#define  CFG_8BITS              2      // Nb bits: 8 bits/sym
                                 
#define  CFG_1STOP              0      // Stop bits: 1 stop bit
#define  CFG_2STOP              1      // Stop bits: 2 stop bits
                                 
#define  CFG_NOPARITY           0      // Parity: none
#define  CFG_EVENPARITY         1      // Parity: even
#define  CFG_ODDPARITY          2      // Parity: odd
                                 
#define  CFG_DMAOFF             0      // DMA: OFF
#define  CFG_DMAON              1      // DMA: ON
                                 
#define  CFG_NOFLOWCTL          0      // Flow control: none
#define  CFG_RTSCTS             1      // Flow control: RTS/CTS
#define  CFG_XONXOFF            2      // Flow control: XON/XOFF
                                 
#define  CFG_FULLFLUSH          0      // Timing config: none
#define  CFG_TEMPOCHAR          1      // Timing config: CHARACTER
#define  CFG_TEMPOFRAME         2      // Timing config: FRAME
                                 
#define  CFG_1MS                0      // Timing: 1 ms
#define  CFG_5MS                1      // Timing: 5 ms
#define  CFG_10MS               2      // Timing: 10 ms
#define  CFG_50MS               3      // Timing: 50 ms
#define  CFG_100MS              4      // Timing: 100 ms
#define  CFG_150MS              5      // Timing: 150 ms
#define  CFG_200MS              6      // Timing: 200 ms
#define  CFG_500MS              7      // Timing: 500 ms
#define  CFG_1000MS             8      // Timing: 1000 ms
                                 
#define  CFG_FAST               0      // Speed: fast
#define  CFG_SLOW               1      // Speed: slow

#define  CFG_P10MS              0      // Software poll delay: 10 msec
#define  CFG_P20MS              1      // Software poll delay: 20 msec
#define  CFG_P50MS              2      // Software poll delay: 50 msec
#define  CFG_P75MS              3      // Software poll delay: 75 msec
#define  CFG_P100MS             4      // Software poll delay: 100 msec

#define  CFG_P1                 0      // Software poll count: 1 time
#define  CFG_P2                 1      // Software poll count: 2 times
#define  CFG_P3                 2      // Software poll count: 3 times
#define  CFG_P4                 3      // Software poll count: 4 times
#define  CFG_P5                 4      // Software poll count: 5 times

#define  CFG_POLL               0      // Monitor mode: polling
#define  CFG_DIFI               1      // Monitor mode: digital filtering
#define  CFG_IRQ                2      // Monitor mode: irq

#define  CFG_D10US              0      // Hardware poll delay: 10 usec
#define  CFG_D20US              1      // Hardware poll delay: 20 usec
#define  CFG_D50US              2      // Hardware poll delay: 50 usec
#define  CFG_D75US              3      // Hardware poll delay: 75 usec
#define  CFG_D100US             4      // Hardware poll delay: 100 usec

#define  CFG_D1                 0      // Hardware poll count: 1 time
#define  CFG_D2                 1      // Hardware poll count: 2 times
#define  CFG_D3                 2      // Hardware poll count: 3 times
#define  CFG_D4                 3      // Hardware poll count: 4 times
#define  CFG_D5                 4      // Hardware poll count: 5 times


/* I2C ......................................................................*/

#define I2C_BUS_1               0      // Bus 1 used

#define I2C_ADDR_EEP_W       0xA0      // Address I2C of the EEPROM (writing)
#define I2C_ADDR_EEP_R       0xA1      // Address I2C of the EEPROM (reading)


/* LCD screen ...............................................................*/

#define I2C_ADDR_SCR_LCD_W   0xC4      // Address I2C of LCD screen (writing)
#define I2C_ADDR_SCR_LCD_R   0xC5      // Address I2C of LCD screen (reading)


/* Structures definitions ---------------------------------------------------*/

typedef struct                         // AUT_USND Context structure
  {                                    // -----------------------------------
    unsigned short  emet             ; // Sender of SND_START/SND_STOP
    unsigned short  evl              ; // "
    unsigned short  nfa              ; // Internal Queue for response

    unsigned int    iod              ; // IOD for myio_send
    unsigned char  *buf              ; // Buffer address
    int             buflg            ; // Number of bytes/bits in buffer
    int             rpt              ; // Repeat count for send_rcu

    int             nbreq            ; // Number of ongoing REQ_WRITE's
    unsigned int    idto             ; // Running TO_RCU identifier
  }                 Usnd_ctx         ; // -----------------------------------

typedef struct                         // One menu transition table line
  {                                    // -----------------------------------
    SHORT            evtcode         ; // Awaited code event (opt value)
    int  (*trt1)() ; SHORT p1        ; // 1st treatment and its parameter
    int  (*trt2)() ; SHORT p2        ; // 2nd treatment and its parameter
    int  (*trt3)() ; SHORT p3        ; // 3rd treatment and its parameter
    int  (*trt4)() ; SHORT p4        ; // 4th treatment and its parameter
    int  (*trt5)() ; SHORT p5        ; // 5th treatment and its parameter
  }                 M_trans          ; // -----------------------------------

typedef struct                         // Text structure
  {                                    // -----------------------------------
    unsigned short  fc               ; // Foreground color
    unsigned short  bc               ; // Background color
    unsigned char   x                ; // Horizontal coordinate
    unsigned char   y                ; // Vertical coordinate
    char           *txt              ; // String address
  }                 Lcd_text         ; // -----------------------------------

